set linesize 32000
set pagesize 1000
set echo on
set termout on
set trimspool on

spool tomkyteexample3.log

-- From http://www.oracle.com/technetwork/issue-archive/2009/09-jan/o19asktom-086775.html
-- When the Optimizer Guesses section
-- Try multi column histograms

-- first get db version

select * from v$version;

drop table t;

create table t
  as select decode( mod(rownum,2), 0, 'N', 'Y' ) flag1,
               decode( mod(rownum,2), 0, 'Y', 'N' ) flag2, a.*
    from all_objects a
/

create index t_idx on t(flag1,flag2);

set autotrace traceonly explain

select * from t where flag1 = 'N' and flag2 = 'N';

set autotrace off

select DBMS_STATS.CREATE_EXTENDED_STATS (NULL,'T','(FLAG1,FLAG2)') from dual;
execute DBMS_STATS.GATHER_TABLE_STATS (NULL,'T',estimate_percent=>NULL,method_opt=>'FOR ALL COLUMNS SIZE 254');

select column_name,num_buckets,last_analyzed
from USER_TAB_COLS 
where table_name = 'T';

select num_rows, num_rows/2, 
num_rows/2/2 from user_tables 
where table_name = 'T';

set autotrace traceonly explain

-- try the sampling levels 0 and 1 - why does 1 work?

select * from t where flag1 = 'N' and flag2 = 'N';

select /*+ dynamic_sampling(t 1) */ * from t where flag1 = 'N' and flag2 = 'N';

spool off
